package geo3dshapes;

import processing.core.PApplet;
import processing.core.PImage;


public class Geo3dShapes extends PApplet {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	PImage image;
	int positions[][];
	
	public void setup() {
		size(600, 600, OPENGL);
		image = loadImage("map.jpg");
		positions = new int[image.width][image.height];
		for(int w=0; w<positions.length; w++){
			for(int h=0; h<positions[w].length; h++){
				positions[w][h] = image.pixels[w+image.width*h]/100000;
			}
		}
	}

	public void draw() {
		background(0);
		lights();
		//scale(2);
		
		noStroke();
		
		//translate(150, 250, -100);
		//rotateY(TWO_PI/360*140);
		translate(175, 250, -150);
		rotateY(map(mouseY, 0, height, -PI, PI));
		rotateZ(TWO_PI/360*-30);
		
		for(int w=0; w<positions.length-1; w++){
			beginShape(TRIANGLE_STRIP);
			texture(image);
			for(int h=0; h<positions[w].length; h++){
				vertex(-150+w, positions[w][h], -150+h, w, h);
				vertex(-150+w+1, positions[w+1][h], -150+h, w+1, h);
			}
			endShape();
		}
		
	}
	
	public static void main(String _args[]) {
		PApplet.main(new String[] { geo3dshapes.Geo3dShapes.class.getName() });
	}
}
